# Stubb

Stubb is a text based gopher client that supports gophertypes: 0 (text) and 1 (gopher map) fully. It offers downloads for other types and offers partial support for type 7 via a default search engine.  The program is named for the character [Stubb from Moby Dick](https://en.wikipedia.org/wiki/List_of_Moby-Dick_characters#Crewmates), known for his imaginative patter and good humor.

Stubb supports bookmarks, tabs, file save, piping to a $PAGER (defaults to less),and session only history (cleared on quit). 

Search has been implemented with a default of Veronica2 as the search service. 

The command bar lists the current tab number, out of how many total tabs. It also lists the current place in history (for the tab you are currently on).



### Setup

Stubb has been tested with Lua versions >= 5.1. I had been told that the socket library is buggy on 5.3, but have not experienced any problems myself. Most testing has been done with 5.1 and 5.2. 

Luasocket is required. It can be acquired via luarocks with: `luarocks install luasocket`. You can also get it via [github](https://github.com/diegonehab/luasocket). Using luarocks is recommended as the easier option.

That should take care of dependencies. You just need to make sure that __stubb__ (found in this repo) is executable and you are good to go.



### Versions

This repo contains two files: `stubb` and `stubb-lite`. The later has a simpler menu structure and lacks support for having multiple tabs open. The filesize and memory usage should be similar, but the navigation may involve fewer keypresses in the lite version. The lite version is not under active development and is provided as a legacy item.


### Commands

Stub responds to single key commands without requiring the user to press enter. Some commands will request further information, such as a link or bookmark id.


* __Navigation__
    * (B)ack
    * (F)orward
    * (G)o to
        * (B)ookmark
        * (L)ink
        * (T)ab
        * (U)rl
    * (R)eload current url
    * (P)ipe to:
        * (R)eader
            * (C)urrent
        * (T)ab
            * (C)urrent
            * (L)ink
        * (D)isk
            * (C)urrent
            * (L)ink
    * (S)earch
            

* __Bookmarks/Tabs__
    * (A)dd
        * (B)ookmark
        * (T)ab
    * (D)elete
        * (B)ookmark
        * (T)ab
    * (L)ist
        * (B)ookmark
        * (T)ab
    * (U)pdate bookmark title

* __System__
    * (C)lean the screen
    * (H)elp
    * (Q)uit Stubb


When a gophermap is loaded, links will be enumerated. Pressing (G) and then (L) will prompt you for what link you would like to follow. Links are always based on the most recently loaded url for your current tab. 

File save is always based out of the home directory of the user that launched Stubb.



### Recommendations

If Stubb's slim and light style is not fitting your needs, or you just want to check out some other gopher client projects, I highly recomend the following:

- [Burrow](https://tildegit.org/sloum/burrow): My gui based browser with a wider featureset (primarily for *nix system)
- [VF-1](https://github.com/solderpunk/VF-1): A great/stable gopher client written by Solderpunk, who maintains one of the best gopher communities out there, [The People's Circumlunar Zaibatsu](gopher://zaibatsu.circumlunar.space:70/) (a part of [Circumlunar Space](http://circumlunar.space/)). 



### Future

Currently, the big item under consideration is a user editable config file. The config would allow a user to change their search engine, default save path, toggle color output, change reader application, etc. 
 
 
 
### Notes

 Stubb is free, as in freedom, software. Modify it as you see fit, give it to whoever you want. It would be great if you referenced the original or cross linked, but it is not required.

